﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Drawing2D;

namespace Ternakan
{
    public partial class VerRelatorio : Form
    {
        public int nFotos1 = 0, nFotos2 = 0;

        public VerRelatorio()
        {
            InitializeComponent();
        }

        public void carregarDsTrabalhadores()
        {
            dsTernakan ds = new dsTernakan();
            try
            {
                //Codigo para o relatorio
                
                ds.ReadXml(frmHome.caminhoXML);
                Cursor.Current = Cursors.WaitCursor;
                RelatorioTrabalhadores objRpt = new RelatorioTrabalhadores();
                objRpt.SetDataSource(ds);
                objRpt.Refresh();
                crystalReportViewer1.ReportSource = objRpt;
                crystalReportViewer1.Refresh();
            }
            catch (Exception)
            {
                MessageBox.Show("Erro ao carregar o relatório");
            }
            finally
            {
                ds.Dispose();
                Cursor.Current = Cursors.Default;
            }
        }

        public void carregarRelatorioNatalidade()
        {
            dsTernakan ds = new dsTernakan();
            try
            {
                ds.ReadXml(frmHome.caminhoXML);
                //Codigo para o relatorio
                Cursor.Current = Cursors.WaitCursor;

                var query = from p in ds.GADO
                            where p.TIPO_CADASTRO == "Nascido"
                            select p;

                DataView dv = query.AsDataView();

                RelatorioNatalidade objRpt = new RelatorioNatalidade();
                objRpt.SetDataSource(dv);
                objRpt.Refresh();
                crystalReportViewer1.ReportSource = objRpt;
                crystalReportViewer1.Refresh();
            }
            catch (Exception)
            {
                MessageBox.Show("Erro ao carregar o relatório");
            }
            finally
            {
                ds.Dispose();
                Cursor.Current = Cursors.Default;
            }
        }

        public void carregarRelatorioEntrada (DateTime dateDe, DateTime dataAte)
        {
            dsTernakan ds = new dsTernakan();
            try
            {
                //Codigo para o relatorio
                Cursor.Current = Cursors.WaitCursor;

               
                ds.ReadXml(frmHome.caminhoXML);

                var query = from p in ds.GADO
                            where ((p.DATA_ENTRADA >= dateDe) && (p.DATA_ENTRADA <= dataAte) &&
                           ((p.TIPO_CADASTRO != "MORTO") || (p.TIPO_CADASTRO != "VENDIDO") || (p.TIPO_CADASTRO != "TROCADO"))              
                            )
                            select p;

                DataView dv = query.AsDataView();

                RelatorioEntradaGadoFim objRpt = new RelatorioEntradaGadoFim();
                objRpt.SetDataSource(dv);
                objRpt.Refresh();
                crystalReportViewer1.ReportSource = objRpt;
                crystalReportViewer1.Refresh();
            }
            catch (Exception)
            {
                MessageBox.Show("Erro ao carregar o relatório");
            }
            finally
            {
                ds.Dispose();
                Cursor.Current = Cursors.Default;
                
            }
        }

        public void carregarRelatorioSaida(DateTime dateDe, DateTime dataAte)
        {
            dsTernakan ds = new dsTernakan();
            try
            {
                //Codigo para o relatorio
                Cursor.Current = Cursors.WaitCursor;

                
                ds.ReadXml(frmHome.caminhoXML);

                var query = from p in ds.SAIDA_ANIMAIS
                            where ((p.DATA_SAIDA >= dateDe) && (p.DATA_SAIDA <= dataAte))
                            select p ;

                dsVirtual dsVirt = new dsVirtual();
                DataTable t = dsVirt.Tables["SAIDA"];
                DataRow r;
                foreach (dsTernakan.SAIDA_ANIMAISRow item in query)
                {
                    r = t.NewRow();

                    r["SEXO"] = item.GADORow.SEXO;
                    r["NUMERO"] = item.GADORow.NUMERO;
                    r["NOME"] = item.GADORow.NOME;
                    r["DATA_SAIDA"] = item.DATA_SAIDA;
                    r["TIPO_SAIDA"] = item.TIPO_SAIDA;
                    r["PRECO"] = item.PRECO;
                    t.Rows.Add(r);

                }


                RelatoriosSaidaGado objRpt = new RelatoriosSaidaGado();
                objRpt.SetDataSource(dsVirt.Tables["SAIDA"]);
                objRpt.Refresh();
                crystalReportViewer1.ReportSource = objRpt;
                crystalReportViewer1.Refresh();
            }
            catch (Exception)
            {
                MessageBox.Show("Erro ao carregar o relatório");
            }
            finally
            {
                ds.Dispose();
                Cursor.Current = Cursors.Default;
            }
        }

        public void carregarRelatorioMortalidade( DateTime dateDe, DateTime dataAte)
        {
            dsTernakan ds = new dsTernakan();
            try
            {
                ds.ReadXml(frmHome.caminhoXML);
                //Codigo para o relatorio
                Cursor.Current = Cursors.WaitCursor;

                var query = from p in ds.MORTALIDADE
                            where ((p.DATA_MORTE >= dateDe) && (p.DATA_MORTE <= dataAte))
                            select p;

                dsVirtual dsVirt = new dsVirtual();
                DataTable t = dsVirt.Tables["VIRTUALMORTE"];
                DataRow r;
                foreach (dsTernakan.MORTALIDADERow item in query)
                {
                    r = t.NewRow();

                    r["CAUSA"] = item.CAUSA;
                    r["SEXO"] = item.GADORow.SEXO;
                    r["NUMERO"] = item.GADORow.NUMERO;
                    r["NOME"] = item.GADORow.NOME;
                    r["DATA_MORTE"] = item.DATA_MORTE;
                    t.Rows.Add(r);

                }


                RelatorioMortalidade objRpt = new RelatorioMortalidade();
                objRpt.SetDataSource(dsVirt.Tables["VIRTUALMORTE"]);
                objRpt.Refresh();
                crystalReportViewer1.ReportSource = objRpt;
                crystalReportViewer1.Refresh();
            }
            catch (Exception)
            {
                MessageBox.Show("Erro ao carregar o relatório");
            }
            finally
            {
                ds.Dispose();
                Cursor.Current = Cursors.Default;
            }
        }

        public void carregarRelatorioPerfilGado()
        {
            dsTernakan ds = new dsTernakan();
            dsFazendasEUsuarios dsFazenda = new dsFazendasEUsuarios();
            try
            {
                ds.ReadXml(frmHome.caminhoXML);

       


                DataTable t = dsFazenda.Tables["FAZENDA"];
                DataRow r = t.NewRow();
                r["NOME_FAZENDA"] = frmHome.fazendaSelecionada.NOME_FAZENDA;
                t.Rows.Add(r);
                //Codigo para o relatorio
                Cursor.Current = Cursors.WaitCursor;
                RelatorioPerfilGado objRpt = new RelatorioPerfilGado();
                objRpt.Database.Tables[0].SetDataSource(ds.Tables["GADO"]);
              //  objRpt.SetDataSource(ds);
                objRpt.Subreports[1].Database.Tables[0].SetDataSource(t);
                objRpt.Subreports[0].Database.Tables[0].SetDataSource(ds.Tables["VACINA"]);
               // objRpt.Refresh();
                crystalReportViewer1.ReportSource = objRpt;
                crystalReportViewer1.Refresh();
            }
            catch (Exception)
            {
                MessageBox.Show("Erro ao carregar o relatório");
            }
            finally
            {
                ds.Dispose();
                Cursor.Current = Cursors.Default;
            }
        }

        public void carregarRelatorioPerfilGado(int id)
        {
            dsTernakan ds = new dsTernakan();
            try
            {
                ds.ReadXml(frmHome.caminhoXML);
                //Codigo para o relatorio
                Cursor.Current = Cursors.WaitCursor;


                dsTernakan dsTeste = new dsTernakan();
                DataTable t = dsTeste.Tables["GADO"];
                DataRow r;
                
                foreach (dsTernakan.GADORow item in ds.GADO)
                {
                    if (item.ID == id)
                    {
                        r = t.NewRow();

                        r["NOME"] = item.NOME;
                        r["NUMERO"] = item.NUMERO;
                        r["DATA_NASCIMENTO_GADO"] = item.DATA_NASCIMENTO_GADO;
                        r["PAI"] = item.PAI;
                        r["MAE"] = item.MAE;
                        r["SEXO"] = item.SEXO;
                        r["RACA"] = item.RACA;
                        r["PELAGEM"] = item.PELAGEM;
                        r["LACTACAO_MEDIA"] = item.LACTACAO_MEDIA;
                        r["NUMERO_FILHOS"] = item.NUMERO_FILHOS;
                        r["NUMERO_DONOS"] = item.NUMERO_DONOS;
                        r["NUMERO_REGISTRO"] = item.NUMERO_REGISTRO;

                        if (!item.IsFOTO1Null())
                        {
                            
                            r["FOTO1"] = item.FOTO1; //(@"abc" + nFotos1.ToString() + ".jpg");
                            nFotos1++;
                        }

                        if (!item.IsFOTO2Null())
                        {

                            r["FOTO2"] = item.FOTO2;//(@"ft2" + nFotos2.ToString() + ".jpg");
                            nFotos1++;
                        }

                        t.Rows.Add(r);
                    }
                }
                //Nome fazenda
                dsFazendasEUsuarios dsFazenda = new dsFazendasEUsuarios();
                DataTable tFazenda = dsFazenda.Tables["FAZENDA"];
                DataRow rFazenda = tFazenda.NewRow();
                rFazenda["NOME_FAZENDA"] = frmHome.fazendaSelecionada.NOME_FAZENDA;
                tFazenda.Rows.Add(rFazenda);
            


                RelatorioPerfilGado objRpt = new RelatorioPerfilGado();
                objRpt.Database.Tables[0].SetDataSource(t);
                //  objRpt.SetDataSource(ds);
                objRpt.Subreports[1].Database.Tables[0].SetDataSource(tFazenda);
                objRpt.Subreports[0].Database.Tables[0].SetDataSource(ds.Tables["VACINA"]);
                crystalReportViewer1.ReportSource = objRpt;
                crystalReportViewer1.Refresh();
            }
            catch (Exception ee)
            {
                MessageBox.Show("Erro ao carregar o relatório\n"+ee.Message);
            }
            finally
            {
                ds.Dispose();
                Cursor.Current = Cursors.Default;
            }
        }

        public void carregarRelatorioProduto(DateTime dateDe, DateTime dataAte)
        {
            dsTernakan ds = new dsTernakan();
            try
            {
                ds.ReadXml(frmHome.caminhoXML);
                //Codigo para o relatorio
               Cursor.Current = Cursors.WaitCursor;

                var query = from p in ds.PRODUTO
                            where ((p.DATA_COMPRA_PRODUTO >= dateDe) && (p.DATA_COMPRA_PRODUTO <= dataAte))
                            select p;

                DataView dv = query.AsDataView();

                RelatorioProdutoFinal objRpt = new RelatorioProdutoFinal();
                objRpt.SetDataSource(dv);
                objRpt.Refresh();
                crystalReportViewer1.ReportSource = objRpt;
                crystalReportViewer1.Refresh();
            }
            catch (Exception)
            {
                MessageBox.Show("Erro ao carregar o relatório");
            }
            finally
            {
                ds.Dispose();
                Cursor.Current = Cursors.Default;
            }
        }

        public void carregarPiquet()
        {

            dsTernakan ds = new dsTernakan();
            try
            {
                ds.ReadXml(frmHome.caminhoXML);

                //Codigo para criar o dsVirtual
                dsVirtual dsVirt = new dsVirtual();
                DataTable t = dsVirt.Tables["PIQUET"];
                DataRow r;
                foreach (dsTernakan.GADORow item in ds.GADO)
                {
                    r = t.NewRow();

                    r["NOME_PIQUET"] = item.PIQUETRow.NOME;
                    r["NUMERO_PIQUET"] = item.PIQUETRow.NUMERO;
                    r["NOME_ANIMAL"] = item.NOME;
                    r["NUMERO_ANIMAL"] = item.NUMERO;
                    t.Rows.Add(r);

                }


                //Codigo para o relatorio
                RelatorioPiquet objRpt = new RelatorioPiquet();
                objRpt.SetDataSource(dsVirt.Tables["PIQUET"]);
                objRpt.Refresh();
                crystalReportViewer1.ReportSource = objRpt;
                crystalReportViewer1.Refresh();

            }
            catch (Exception)
            {
                MessageBox.Show("Erro ao carregar o relatório");
            }
            finally
            {
                ds.Dispose();
                Cursor.Current = Cursors.Default;
            }
        }
    }
}
