﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Ternakan
{
    public partial class frmLactacaoDiaria : Form
    {
        public frmLactacaoDiaria()
        {
            InitializeComponent();
        }

        private void btSairLactacaoDiaria_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void frmLactacaoDiaria_Shown(object sender, EventArgs e)
        {
            dsTernakan.ReadXml(frmHome.caminhoXML);
            lerDados();
        }

        private void lerDados()
        {
            var query = from p in dsTernakan.LACTACAO select p;
            dsVirtual dsVirt = new dsVirtual();
            DataTable t = dsVirt.Tables["LACTACAOSEMANAL"];
            DataRow r;
            foreach (dsTernakan.LACTACAORow item in query)
            {
                r = t.NewRow();
                r["ID"] = item.ID;
                r["ID_GADO"] = item.ID_GADO;
                r["NOME"] = item.GADORow.NOME;
                r["NUMERO"] = item.GADORow.NUMERO;
                r["DOMINGO"] = item.DOMINGO;
                r["SEGUNDA"] = item.SEGUNDA;
                r["TERCA"] = item.TERCA;
                r["QUARTA"] = item.QUARTA;
                r["QUINTA"] = item.QUINTA;
                r["SEXTA"] = item.SEXTA;
                r["SABADO"] = item.SABADO;
                t.Rows.Add(r);
            }
            lACTACAOSEMANALBindingSource.DataSource = dsVirt;
            dgControleLactacaoDiaria.Refresh();
        }

        private void dgControleLactacaoDiaria_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private bool persistirDados()
        {
            foreach (DataGridViewRow item in dgControleLactacaoDiaria.Rows)
            {
                dsTernakan.LACTACAORow lactacao = (from p in dsTernakan.LACTACAO
                                                   where p.ID == Convert.ToInt32(item.Cells[0].Value)
                                                   select p).First();
                if (item.Cells[3].Value.ToString() == "")
                {
                    item.Cells[3].Value = "0";
                }
                if (item.Cells[4].Value.ToString() == "")
                {
                    item.Cells[4].Value = "0";
                }
                if (item.Cells[5].Value.ToString() == "")
                {
                    item.Cells[5].Value = "0";
                }
                if (item.Cells[6].Value.ToString() == "")
                {
                    item.Cells[6].Value = "0";
                }
                if (item.Cells[7].Value.ToString() == "")
                {
                    item.Cells[7].Value = "0";
                }
                if (item.Cells[8].Value.ToString() == "")
                {
                    item.Cells[8].Value = "0";
                }
                if (item.Cells[9].Value.ToString() == "")
                {
                    item.Cells[9].Value = "0";
                }
                try
                {
                    lactacao.DOMINGO = Convert.ToInt32(item.Cells[3].Value);
                    lactacao.SEGUNDA = Convert.ToInt32(item.Cells[4].Value);
                    lactacao.TERCA = Convert.ToInt32(item.Cells[5].Value);
                    lactacao.QUARTA = Convert.ToInt32(item.Cells[6].Value);
                    lactacao.QUINTA = Convert.ToInt32(item.Cells[7].Value);
                    lactacao.SEXTA = Convert.ToInt32(item.Cells[8].Value);
                    lactacao.SABADO = Convert.ToInt32(item.Cells[9].Value);
                }
                catch (Exception)
                {
                    MessageBox.Show("Favor preencher os campos corretamente");
                    return false;
                }
            }
            return true;
        }

        private void frmLactacaoDiaria_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (MessageBox.Show("Você deseja confirmar as alterações antes de sair", "Confirmação", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                if (persistirDados() == true)
                {
                    MessageBox.Show("Dados armazenados com sucesso");
                }
            }

            dsTernakan.WriteXml(frmHome.caminhoXML);
            dsTernakan.Dispose();
        }

        private void btConfirmarLactacao_Click(object sender, EventArgs e)
        {
            if (persistirDados() == true)
            {
                MessageBox.Show("Dados armazenados com sucesso");
            }
        }

        private void frmLactacaoDiaria_FormClosing_1(object sender, FormClosingEventArgs e)
        {

        }
    }
}
