﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Ternakan
{
    public partial class frmRemoverCruzamento : Form
    {
        public frmRemoverCruzamento()
        {
            InitializeComponent();
        }

        private void btSairRemoverCruzamento_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void frmRemoverCruzamento_Shown(object sender, EventArgs e)
        {
            dsTernakan.ReadXml(frmHome.caminhoXML);
            carregarDataGrid();
        }

        private void carregarDataGrid()
        {
            try
            {
                //Codigo para o relatorio
                Cursor.Current = Cursors.WaitCursor;


                var query = from p in dsTernakan.CRUZAMENTO
                            select p;
                //criar tabela dsVirtual e associar dinamicamente...
                dsVirtual dsVirt = new dsVirtual();
                DataTable t = dsVirt.Tables["CRUZAMENTO"];
                DataRow r;
                foreach (dsTernakan.CRUZAMENTORow item in query)
                {
                   
                    r = t.NewRow();

                    r["RACA_VACA"] = item.GADORowByCRUZAMENTO_GADO.RACA;
                    r["NUMERO_VACA"] = item.GADORowByCRUZAMENTO_GADO.NUMERO;
                    r["NOME_VACA"] = item.GADORowByCRUZAMENTO_GADO.NOME;
                    r["RACA_BOI"] = item.GADORow.RACA;
                    r["NUMERO_BOI"] = item.GADORow.NUMERO;
                    r["NOME_BOI"] = item.GADORow.NOME;
                    r["ID"] = item.ID;
                    r["DATA_CRUZAMENTO"] = item.DATA_CRUZAMENTO;
                    r["DATA_PREVISTA"] = item.DATA_CRUZAMENTO.AddDays(270);
                    t.Rows.Add(r);

                }

                cRUZAMENTOBindingSource1.DataSource = dsVirt;
                dataGridView1.Refresh();

                
            }
            catch (Exception)
            {
                MessageBox.Show("Erro ao carregar a tabela");
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }

        private void btRemoverCruzamentos_Click(object sender, EventArgs e)
        {
         
            frmDadosVacinas frm = new frmDadosVacinas();
            if (dataGridView1.SelectedRows.Count > 0)
            {
                if (MessageBox.Show("Você tem certeza que deseja remover os cruzamentos selecionados", "Confirmação", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {
                    for (int i = 0; i < dataGridView1.SelectedRows.Count; i++)
                    {
                        if (dataGridView1.Rows[i].Cells[0].Value != null)
                        {
                            try
                            {
                                dsTernakan.CRUZAMENTORow cruzamento = (from c in dsTernakan.CRUZAMENTO
                                                           where c.ID == Convert.ToInt32(dataGridView1.Rows[i].Cells[6].Value.ToString())
                                                           select c).First();

                                dsTernakan.CRUZAMENTO.RemoveCRUZAMENTORow(cruzamento);
                            }
                            catch (Exception ee)
                            {

                                MessageBox.Show("Erro ao tentar remover.\n" + ee.Message);
                            }
                            finally
                            {
                                MessageBox.Show("Cruzamento removido com sucesso!");
                                Close();
                            }
                        }
                    }
                }
            }
            else
            {
                MessageBox.Show("Não há nenhum cruzamento selecionado");
            }
        }

        private void frmRemoverCruzamento_FormClosed(object sender, FormClosedEventArgs e)
        {
            dsTernakan.WriteXml(frmHome.caminhoXML);
            dsTernakan.Dispose();
        }
    }
}
