﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Ternakan
{
    public partial class frmSelecionarFazenda : Form
    {
        private bool logado = false;
        public frmSelecionarFazenda()
        {
            InitializeComponent();
        }

    

        private void cbListaFazendasCadastradas_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void frmSelecionarFazenda_Shown(object sender, EventArgs e)
        {
            dsFazendasEUsuarios.Clear();
            dsFazendasEUsuarios.ReadXml(frmHome.caminhoXMLFazenda);

            //Evitar erros no primeiro acesso
            while (cbListaFazendasCadastradas.Items.Count < 1)
            {
                if (MessageBox.Show("Não há fazenda cadastradas\nDeseja cadastrar?","Informação",MessageBoxButtons.YesNo) == DialogResult.No)
                    Application.Exit();
                
                frmFazendaCadastro frm = new frmFazendaCadastro();
                frm.ShowDialog();
                dsFazendasEUsuarios.Clear();
                dsFazendasEUsuarios.ReadXml(frmHome.caminhoXMLFazenda);
            }
            while (dsFazendasEUsuarios.USUARIOS.Count < 1)
            {
                if (MessageBox.Show("Não há usuários cadastrados\nDeseja cadastrar?","Informação",MessageBoxButtons.YesNo) == DialogResult.No)
                    Application.Exit();
                
                frmCadastroUsuarios frm = new frmCadastroUsuarios();
                frm.ShowDialog();
                dsFazendasEUsuarios.Clear();
                dsFazendasEUsuarios.ReadXml(frmHome.caminhoXMLFazenda);
            }

        }

        private void logar()
        {
            frmHome.fazendaSelecionada = (from f in dsFazendasEUsuarios.FAZENDA
                                          where f.ID == Convert.ToInt32(cbListaFazendasCadastradas.SelectedValue)
                                          select f).First();

            var query = from u in dsFazendasEUsuarios.USUARIOS
                        where (u.FAZENDARow == frmHome.fazendaSelecionada)
                        select u;
            if (query.Count() > 0)
            {
                var q2 = from usuarios in query
                         where ((usuarios.USUARIO.ToUpper() == txtUsuario.Text.ToUpper()) &&
                         (usuarios.SENHA == txtSenha.Text))
                         select usuarios;

                if (q2.Count() > 0)
                {
                    frmHome.admin = (q2.First().PERMISAO == 1);
                    frmHome.caminhoXML = @"BD" + frmHome.fazendaSelecionada.NOME_FAZENDA;
                    logado = true;
                    Close();
                }
                else
                {
                    MessageBox.Show(@"Usuário e/ou Senha inválida");
                }
            }
            else
            {
               if (MessageBox.Show("Não há usuários cadastrados para esta fazenda.\nDeseja cadastrar agora?","Informação",MessageBoxButtons.YesNo) == DialogResult.Yes)
               {
                    frmCadastroUsuarios frm = new frmCadastroUsuarios();
                    frm.ShowDialog();
                    dsFazendasEUsuarios.Clear();
                    dsFazendasEUsuarios.ReadXml(frmHome.caminhoXMLFazenda);
               }
            }
            txtSenha.Clear();
            txtUsuario.Clear();
            txtUsuario.Focus();
        }

        private void btConfirma_Click(object sender, EventArgs e)
        {
            logar();
        }

        private void txtSenha_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)(Keys.Enter))
                logar();
        }

        private void frmSelecionarFazenda_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (logado == false)
            {
                Application.Exit();
            }
        }
    }
}
